/*
 *		IPFW_MOD_TEST a firewall module test
 *
 *
 * Version:	@(#)ipfw_mod_test.c 0.01   07/18/99
 *
 * Author:	galt (galt@cowofdoom.com)
 *		
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version
 *	2 of the License, or (at your option) any later version.
 *	
 *	
 */

#include <linux/module.h>

#include <linux/config.h>
#include <asm/segment.h>
#include <asm/system.h>
#include <linux/types.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/string.h>
#include <linux/errno.h>
#include <linux/config.h>

#include <linux/socket.h>
#include <linux/sockios.h>
#include <linux/in.h>
#include <linux/inet.h>
#include <linux/netdevice.h>
#include <linux/icmp.h>
#include <linux/udp.h>
#include <linux/firewall.h>
#include <linux/ip_fw.h>

#include <linux/proc_fs.h>
#include <linux/stat.h>

#if CONFIG_MODVERSIONS==1
#define MODVERSIONS
#include <linux/modversions.h>
#endif

int ipfw_mod_test_input_chk(struct iphdr *ip, struct device *rif)
{
	struct ip_fw *f;
	struct tcphdr		*tcp=(struct tcphdr *)((__u32 *)ip+ip->ihl);
	struct udphdr		*udp=(struct udphdr *)((__u32 *)ip+ip->ihl);
	struct icmphdr		*icmp=(struct icmphdr *)((__u32 *)ip+ip->ihl);
	__u32			src, dst;

	src = ip->saddr;
	dst = ip->daddr;

	/* do some checking on the packet and drop it, optionally by returing
		FW_REJECT or FW_BLOCK, etc */
	
	return FW_ACCEPT;
}

int ipfw_mod_test_output_chk(struct iphdr *ip, struct device *rif)
{
	struct ip_fw *f;
	struct tcphdr		*tcp=(struct tcphdr *)((__u32 *)ip+ip->ihl);
	struct udphdr		*udp=(struct udphdr *)((__u32 *)ip+ip->ihl);
	struct icmphdr		*icmp=(struct icmphdr *)((__u32 *)ip+ip->ihl);
	__u32			src, dst;

	src = ip->saddr;
	dst = ip->daddr;

	/* do some checking on the packet and drop it, optionally by returing
		FW_REJECT or FW_BLOCK, etc */
	
	return FW_ACCEPT;
}

int ipfw_mod_test_input_check(struct firewall_ops *this, int pf, struct device *dev, void *phdr, void *arg)
{
	return ipfw_mod_test_input_chk(phdr, dev);
}

int ipfw_mod_test_output_check(struct firewall_ops *this, int pf, struct device *dev, void *phdr, void *arg)
{
	return ipfw_mod_test_output_chk(phdr, dev);
}

struct firewall_ops ipfw_mod_test_ops=
{
	NULL,
	NULL,
	ipfw_mod_test_input_check,
	ipfw_mod_test_output_check,
	PF_INET,
	1	/* priority set to 1 to have priority over ip_fw.c */
};

int ipfw_mod_test_init(void) {
	if(register_firewall(PF_INET,&ipfw_mod_test_ops)<0) {
		printk("ipfw_mod_test: unable to register firewall");
		return 1;
	}
	return 0;
}

int ipfw_mod_test_done(void) {
	if(unregister_firewall(PF_INET, &ipfw_mod_test_ops)<0) {
		printk("ipfw_mod_test: unable to unregister firewall");
		return 1;
	}
	return 0;
} 

int init_module(void) {
	if (ipfw_mod_test_init()!=0)
		return -EIO;
	register_symtab(0);
	printk("ipfw_mod_test: loaded\n");
	return 0;
}

void cleanup_module(void) {
	if(ipfw_mod_test_done()!=0)
		printk("ipfw_mod_test: can't remove module");
	else
		printk("ipfw_mod_test: removed\n");
}